//+------------------------------------------------------------------+
//|                                                         haco.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Heikin-Ashi Candlestick Oscillator                               |
//| Developed by Sylvain Vervoort (TASC december 2008)               |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   PaleVioletRed
#property indicator_width1   2
#property indicator_minimum -1.1
#property indicator_maximum  1.1

//
//
//
//
//

extern int Length = 34;

//
//
//
//
//

double buffer1[];
double tBuffer[][15];
double alpha;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); 
   alpha = 2.0 /(1.0 + Length);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define _upk 12
#define _upa 13
#define _hao 14

//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
   int i,r,limit;

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = Bars-countedBars;
         if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);
   
   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-limit-1; i >= 0; i--,r++)
   {
      double hac   = haC(i,r);
      double temaa = zeroLagTema(hac                 ,r,0);
      double temab = zeroLagTema((High[i]+Low[i])/2.0,r,6);

      //
      //
      //
      //
      //
      
         bool up1 = ((MathAbs(Close[i]-Open[i]) < (High[i]-Low[i])*0.35) && (High[i] >= Low[i+1]));
         bool upk = (hac >= tBuffer[r][_hao] || (temab-temaa)>=0);
            if (upk)
                  tBuffer[r][_upk] =  1;
            else  tBuffer[r][_upk] = -1;
         bool  upa = (upk || (tBuffer[r-1][_upk]==1 && Close[i]>=Close[i+1]));
            if (upa)
                  tBuffer[r][_upa] =  1;
            else  tBuffer[r][_upa] = -1;

      //
      //
      //
      //
      //
            
      if (upa || (tBuffer[r-1][_upa]==1 && up1))
            buffer1[i] =  1;
      else  buffer1[i] = -1;       
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double haC(int i, int r)
{
   double haClose = (High[i+1]+Low[i+1]+Open[i+1]+Close[i+1])/4.0;
   double median  = (High[i]+Low[i])/2.0;
   double haOpen  = (haClose+tBuffer[r-1][_hao])/2.0;
      double haC  = (median + haOpen + MathMax(haOpen,High[i])+ MathMin(haOpen,Low[i]))/4.0;
   tBuffer[r][_hao] = haOpen;      
   return(haC);
}

//
//
//
//
//

double zeroLagTema(double price,int pos,int buff)
{
   double temaa = iTema(price,pos,buff);
   double temab = iTema(temaa,pos,buff+3);
   return(2.0*temaa-temab); 
}

//
//
//
//
//

double iTema(double price,int i,int sbuf=0)
{
   int ia = sbuf+0;
   int ib = sbuf+1;
   int ic = sbuf+2;
   
   if (i < 1)
      {
         tBuffer[i][ia] = price;
         tBuffer[i][ib] = price;
         tBuffer[i][ic] = price;
      }
   else
      {
         tBuffer[i][ia] = tBuffer[i-1][ia]+alpha*(price         -tBuffer[i-1][ia]);
         tBuffer[i][ib] = tBuffer[i-1][ib]+alpha*(tBuffer[i][ia]-tBuffer[i-1][ib]);
         tBuffer[i][ic] = tBuffer[i-1][ic]+alpha*(tBuffer[i][ib]-tBuffer[i-1][ic]);
      }
   return(3*tBuffer[i][ia] - 3*tBuffer[i][ib] + tBuffer[i][ic]);
}